#include <stdio.h>

#include "SDL.h"

#define USE_FLT

#include "tri_rend.h"



SDL_Surface* alloc_imit_surf( SDL_Surface *old )
{
	return
	(
		SDL_CreateRGBSurface
		(
			old->flags,
			
			old->w, old->h,
			
			old->format->BitsPerPixel,
			
			old->format->Rmask,
			old->format->Gmask,
			old->format->Bmask,
			old->format->Amask
		)
	);
}



int main( int argn, char *argc[] )
{
	tri_info data;
	TRI dest_t, src_t;
	SDL_Surface *src_i, *dest_i;
	
	
	
	printf( "\nTextured trangle test starting.\n" );
	
	
	
		/* Init. */
	if( SDL_Init( 0 ) < 0 )
	{
		printf( "SDL_Init failed: %s\n", SDL_GetError() );
	}
	
	
	data.src_tri = &src_t;
	data.dest_tri = &dest_t;
	
	
	src_i = SDL_LoadBMP( "Base1.bmp" );
	if( !src_i )
	{
		printf( "Failed to load Base1.bmp: %s\n", SDL_GetError() );
	}
	
	dest_i = alloc_imit_surf( src_i );
	if( !dest_i )
	{
		printf( "Failed to allocate destination surface: %s\n", SDL_GetError() );
	}
	
	data.src = src_i;
	data.dest = dest_i;
	
	
	data.src_fill = SDL_MapRGBA
						(
							src_i->format,
							
							0,   /* R */
							128, /* G */
							0,   /* B */
							128  /* A */
						);
	
	
	
	/* Place the two triangles. */
	
	src_t.x[ 0 ] = src_i->w * 0.25; src_t.x[ 1 ] = src_i->w * 0.25; src_t.x[ 2 ] = src_i->w * 0.75;
		src_t.y[ 0 ] = src_i->h * 0.25; src_t.y[ 1 ] = src_i->h * 0.75; src_t.y[ 2 ] = src_i->h * 0.75;
	
	dest_t.x[ 0 ] = dest_i->w * 0.75; dest_t.x[ 1 ] = dest_i->w * 0.75; dest_t.x[ 2 ] = dest_i->w * 0.25;
		dest_t.y[ 0 ] = dest_i->h * 0.25; dest_t.y[ 1 ] = dest_i->h * 0.75; dest_t.y[ 2 ] = dest_i->h * 0.75;
	
	
	
	printf( "TRI_REND() result: %i;\n", (int)( TRI_REND( &data, &dest_t, &src_t ) ) );
	
	
	
	if( SDL_SaveBMP( dest_i, "Result1.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface: %s\n", SDL_GetError() );
	}
	
	
	
		/* Close. */
	SDL_FreeSurface( src_i );
	SDL_Quit();
	printf( "Done.\n" );
}
